import { useState } from 'react';
import { Controlled as ControlledEditor } from 'react-codemirror2';

export function Editor(props) {
    const {
      language,
      displayName,
      value,
      onChange
    } = props
    const [open, setOpen] = useState(true)
  
    function handleChange(editor, data, value) {
      onChange(value)
    }
  
    return (
      <div className={`editor-container ${open ? '' : 'collapsed'}`}>
        <div className="editor-title">
          {displayName}
          <button
            type="button"
            className="expand-collapse-btn"
            onClick={() => setOpen(prevOpen => !prevOpen)}
          >
          </button>
        </div>
        <ControlledEditor
          onBeforeChange={handleChange}
          value={value}
          className="code-mirror-wrapper"
          options={{
            lineWrapping: true,
            lint: true,
            mode: language,
            theme: 'material',
            lineNumbers: true
          }}
        />
      </div>
    )
  }
